const APIError = require('./api-errors/api-error');
const logger = require('./logger/logger');
var httpErrorCodes = require('./enums/error-codes.enum');

function ErrorHandlerMiddleware(options = null) {
    const log = new logger(options.environment, options.configuration);
    return async (err, req, res, next) => {
        errorResponse = (error, req, res) => {
            if (error instanceof APIError) {
                res.status(error.httpCode).send({ message: error.message });
                return;
            }
            res.status(httpErrorCodes.INTERNAL_SERVER).send({ message: 'Something went wrong!' });
        }

        try {
            errorResponse(err, req, res);
            await log.error(
                `Error message from the centralized error-handling component => ${err.message} !!`, { stacktrace: err.stack }
            );
        } catch (err) {
            console.log('Error in logging');
        };
        next();
    }
}

module.exports = ErrorHandlerMiddleware;
module.exports.APIError = APIError;
module.exports.httpErrorCodes = httpErrorCodes;